Github Issues built with Backbone.js
==============

An example backbone.js application that replicates Github Issues using their REST api: http://developer.github.com/v3/

Allows you to browse issues, as well as create new issues and comment.

Built with:

*   Backbone.js v0.5.3
*   Underscore.js v1.2.0
*   jQuery v1.7
*   iCanHaz.js v0.9
*   Twitter Bootstrap (including modal plugin)

For development, it's using:

*   Coffeescript
*   Docco (documentation)
*   SASS (css)
*   Sinatra (to serve assets in localhost)
*   Guard (to autogenerate SCSS/Coffeescript)
*   Jammit (to compress vendor folder assets into a single js file)

To run the sinatra server to load the application locally, in root directory run:

    $ ruby app.rb

To autogenerate coffeescript/SASS run in root:

    $ guard

To regenerate vendor.js from the public/vendor js files, run in root:

    $ jammit

To regenerate docco annotated source, run in public folder:

    $ docco ../src/coffee/*.coffee

Example
=======

http://dmix.ca/backbone_github_issues/index.html