(function() {
  var OAuthController, UserView;
  var __hasProp = Object.prototype.hasOwnProperty, __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor; child.__super__ = parent.prototype; return child; };

  OAuthController = (function() {

    __extends(OAuthController, Backbone.Router);

    function OAuthController() {
      OAuthController.__super__.constructor.apply(this, arguments);
    }

    OAuthController.prototype.routes = {
      "oauth": "oauth"
    };

    OAuthController.prototype.oauth = function() {
      var auth_token;
      $('#OAuthModal').modal({
        backdrop: true,
        show: true
      });
      auth_token = App.Functions.getUrlParameter("auth_token");
      App.Functions.storeToken(auth_token);
      return App.Functions.retrieveUser(auth_token);
    };

    return OAuthController;

  })();

  App.Controllers.OAuth = new OAuthController;

  UserView = (function() {

    __extends(UserView, Backbone.View);

    function UserView() {
      UserView.__super__.constructor.apply(this, arguments);
    }

    UserView.prototype.initialize = function() {
      return this.template = ich.user;
    };

    UserView.prototype.render = function() {
      $(this.el).html(this.template(App.Models.User));
      return this;
    };

    return UserView;

  })();

  App.Views.UserView = UserView;

  App.Functions.retrieveUser = function(auth_token) {
    return $.ajax({
      type: 'GET',
      url: 'https://api.github.com/user?access_token=' + auth_token,
      success: function(data) {
        App.Functions.storeUser(data);
        $('#OAuthModal').modal('hide');
        return window.location = "/index.html";
      },
      error: function(request, error) {
        return alert("Failed to retrieve user: " + request.responseText);
      }
    });
  };

  App.Functions.storeToken = function(auth_token) {
    return localStorage.setItem('auth_token', auth_token);
  };

  App.Functions.storeUser = function(user) {
    localStorage.setItem('login', user.login);
    localStorage.setItem('avatar_url', user.avatar_url);
    localStorage.setItem('url', user.html_url);
    return localStorage.setItem('name', user.name);
  };

  App.Functions.logOut = function() {
    localStorage.clear();
    $('#userView').html('<a href="http://dmix.ca/auth/github" class="btn ">Login with Github</a>');
    return alert("Logged out");
  };

  App.Functions.logIn = function() {
    if (localStorage.getItem('auth_token') !== null) {
      App.Functions.loadUser();
      return true;
    }
  };

  App.Functions.loadUser = function() {
    var view;
    if (localStorage.getItem('auth_token') !== null) {
      App.Models.User = {
        login: localStorage.getItem('login'),
        avatar_url: localStorage.getItem('avatar_url'),
        url: localStorage.getItem('url'),
        name: localStorage.getItem('name'),
        auth_token: localStorage.getItem('auth_token')
      };
      view = new App.Views.UserView();
      return $('#userView').html(view.render().el);
    }
  };

  App.Functions.auth_token = function() {
    var token;
    token = localStorage.getItem('auth_token') ? localStorage.getItem('auth_token') : "";
    return "?access_token=" + token;
  };

}).call(this);
